# ifndef SMART_AKK_H
# define SMART_AKK_H

# include <stdio.h>
# include <string.h>
# include <time.h>

# include "drivers/capture/capture.h"
# include "drivers/wait/wait.h"
# include "parts/m55800/eb55.h"
# include "parts/m55800/lib_m55800.h"
# include "periph/stdc/std_c.h"
# include "periph/usart/usart.h"

# define ADBG		1
# define BIO_DBG 1

# define SERIAL_COUNT 0x8


/* Define Baud Rate. CD = 52 */
# define BAUDS38400	(32000000 / (16 * 38400))
# define BAUDS19200     (32000000 / (16 * 19200))

extern void wake_up_handler (void);
WaitDesc wait_desc = { &TC0_DESC, 0, 0, WAIT_DELAY, wake_up_handler };

/* * * * * * * * * * * TEA * * * * * * * * * * */
/* AH: User requested AKV action command */
unsigned int buttonV0;
/* AH: AKV action command label */
unsigned int buttonV1;

/* Encrypted AKV Action Packet */
unsigned int encV0; 
unsigned int encV1;

/* AH: 	VIN # for a Mercedes-Benz C63 AMG */
/*	WDDG F77X 99F2 35313 => 23DD7 F7726 99F2 35313*/
unsigned int VIN0		=	0x23DD7;
unsigned int VIN1		=	0xF7726;
unsigned int VIN2		=	0x99F2;
unsigned int VIN3		=	0x35313;

/* * * * * * * * * * * X-BEE * * * * * * * * * */
unsigned int endPacketByte	=	0xFF;
unsigned int startPacketByte	=	0xAA;

int fingerPrint = 1;
int buttonSequence = 2;
int encryption = 3;
int packet = 4;
int enrollNewFinger = 5;
int enrollNewMaster = 6;
int systemReady = 8;

u_int mcki_detect ( void );
void initAll(void);


# endif
