/* tea.c */

unsigned int delta = 0x9e3779b9; /* a key schedule constant */

unsigned int encipherA (unsigned int v0, unsigned int v1, unsigned int k0, unsigned int k1, unsigned int k2, unsigned int k3) 
{
    unsigned int newV0 = v0, newV1 = v1, sum = 0; /* set up */
    int n = 32;
    
    while(n-- > 0) 
    {
	sum += delta;
	newV0 += ((newV1<<4) ^ k0) ^(newV1 + sum) ^ ((newV1 >> 5) + k1);
	newV1 += ((newV0<<4) ^ k2) ^(newV0 + sum) ^ ((newV0 >> 5) + k3);
    } 
    return newV0;
}

unsigned int encipherB (unsigned int v0, unsigned int v1, unsigned int k0, unsigned int k1, unsigned int k2, unsigned int k3) 
{
    unsigned int newV0 = v0, newV1 = v1, sum = 0; /* set up */
    int n = 32;
    while(n-- > 0) 
    {
	sum += delta;
	newV0 += ((newV1<<4) ^ k0) ^(newV1 + sum) ^ ((newV1 >> 5) + k1);
	newV1 += ((newV0<<4) ^ k2) ^(newV0 + sum) ^ ((newV0 >> 5) + k3);
    }
    return newV1;
}

unsigned int decipherA (unsigned int v0, unsigned int v1, unsigned int k0, unsigned int k1, unsigned int k2, unsigned int k3) 
{
    unsigned int oldV0 = v0, oldV1 = v1, sum = 0; /* set up */
    int n = 32;

    sum = delta << 5;
	
    while(n-- > 0) 
    {
	oldV1 -= ((oldV0<<4) ^ k2) ^(oldV0 + sum) ^ ((oldV0 >> 5) + k3);
	oldV0 -= ((oldV1<<4) ^ k0) ^(oldV1 + sum) ^ ((oldV1 >> 5) + k1);
	sum -= delta;
    }
    return oldV0;
}

unsigned int decipherB (unsigned int v0, unsigned int v1, unsigned int k0, unsigned int k1, unsigned int k2, unsigned int k3) 
{
    unsigned int oldV0 = v0, oldV1 = v1, sum = 0; /* set up */
    int n = 32;
    
    sum = delta << 5;

    while(n-- > 0) 
    {
	oldV1 -= ((oldV0<<4) ^ k2) ^(oldV0 + sum) ^ ((oldV0 >> 5) + k3);
	oldV0 -= ((oldV1<<4) ^ k0) ^(oldV1 + sum) ^ ((oldV1 >> 5) + k1);
	sum -= delta;
    }
    return oldV1;
}
