#ifdef SEMIHOSTING
#include <stdio.h>
#endif

# include <stdio.h>
# include <string.h>
# include <time.h>

# include "drivers/capture/capture.h"
# include "drivers/wait/wait.h"
# include "parts/m55800/eb55.h"
# include "parts/m55800/lib_m55800.h"
# include "periph/stdc/std_c.h"
# include "periph/usart/usart.h"

/* Define Baud Rate. CD = 52 */
# define BAUDS38400	(32000000 / (16 * 38400)) 
# define ADBG		1



extern void wake_up_handler (void);
WaitDesc wait_desc = { &TC0_DESC, 0, 0, WAIT_DELAY, wake_up_handler };

unsigned int LedSpeed = 200000;

unsigned int serialNum = 0x0;


int noError;

/* * * * * * * * * * * TEA * * * * * * * * * * */
unsigned int initial	=	0x88888888;

unsigned int AKVL	= 	0x99999999; 

const unsigned int SERIAL_COUNT = 0x8;

unsigned int LCK 		=	0x11111111; 
unsigned int ULCK		=	0x11112222;

unsigned int EGN		=	0x22222222;
unsigned int EGF 		= 	0x22223333;

unsigned int PNC		=	0x33333333;

/* AH: User requested AKV action command */
unsigned int buttonV0;
/* AH: AKV action command label */
unsigned int buttonV1;

/* Encrypted AKV Action Packet */
unsigned int decV0; 
unsigned int decV1;

unsigned int akkPacket[10];

/* AH: 	VIN # for a Mercedes-Benz C63 AMG */
/*	WDDG F77X 99F2 35313 => 23DD7 F7726 99F2 35313*/
unsigned int VIN0		=	0x23DD7;
unsigned int VIN1		=	0xF7726;
unsigned int VIN2		=	0x99F2;
unsigned int VIN3		=	0x35313;

/* * * * * * * * * * * X-BEE * * * * * * * * * */
unsigned int endPacketByte	=	0xFF;
unsigned int startPacketByte	=	0xAA;

unsigned int firstByte		=	0x00;
unsigned int lastByte		=	0x00;
unsigned int aByte		=	0x0;

/* Master Clock Frequency Detection. Output: Frequency in kHz */
u_int mcki_detect ( void )
{
    int period;

    at91_capture_open ( &TC0_DESC, MODE_TIOA_PERIOD ) ;
    while ( at91_capture_get_status ( &TC0_DESC ) != TRUE ) ;
    period = at91_capture_read ( &TC0_DESC ) ;
    at91_capture_close ( &TC0_DESC ) ;

    if ( period > 15 )
        return ( MCKKHz ) ;
    if ( period > 7 )
        return ( MCKKHz >> 1 ) ;
    if ( period > 3 )
        return ( MCKKHz >> 2 ) ;
    if ( period > 1 )
        return ( MCKKHz >> 3 ) ;

    return ( MCKKHz >> 4 ) ;
}

void initAll(void)
{
    noError = 1;

    buttonV0 = 0x00000000;
    buttonV1 = 0x00000000;

    decV0 = 0x0; 
    decV1 = 0x0;

}

void executeLOCK( void )
{
    /* Lights all LED1 - LED8 once */
    at91_pio_open ( &PIOB_DESC, LED_MASK, PIO_OUTPUT ) ;
    at91_pio_write (&PIOB_DESC, LED_MASK, LED_ON ) ;
    wait_desc.period = 200000 ;

    at91_wait_open ( &wait_desc ) ;
    at91_pio_write (&PIOB_DESC, LED_MASK, LED_OFF ) ;
    at91_wait_open ( &wait_desc ) ;

}

void executeUNLOCK( void )
{
    /* Lights all LED1 - LED8 twice */
    int i;

    for(i = 0; i < 2; i++)
    {
	at91_pio_open ( &PIOB_DESC, LED_MASK, PIO_OUTPUT ) ;
	at91_pio_write (&PIOB_DESC, LED_MASK, LED_ON ) ;
	wait_desc.period = 200000 ;

	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED_MASK, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
    }	
}

void executeENGINE_ON( void )
{
        int j;
    LedSpeed = 100000;

    for(j = 0 ; j < 3 ; j++ )
    {	
	at91_pio_write (&PIOB_DESC, LED1, LED_ON ) ;
	wait_desc.period = LedSpeed ;

	at91_pio_write (&PIOB_DESC, LED2, LED_ON ) ;
	wait_desc.period = LedSpeed ;

	at91_pio_write (&PIOB_DESC, LED3, LED_ON ) ;
	wait_desc.period = LedSpeed ;

	at91_pio_write (&PIOB_DESC, LED4, LED_ON ) ;
	wait_desc.period = LedSpeed ;

	at91_pio_write (&PIOB_DESC, LED5, LED_ON ) ;
	wait_desc.period = LedSpeed ;
	at91_pio_write (&PIOB_DESC, LED6, LED_ON ) ;
	wait_desc.period = LedSpeed ;

	at91_pio_write (&PIOB_DESC, LED7, LED_ON ) ;
	wait_desc.period = LedSpeed ;

	at91_pio_write (&PIOB_DESC, LED8, LED_ON ) ;
	wait_desc.period = LedSpeed ;

	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED1, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED2, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED3, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED4, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED5, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED6, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED7, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED8, LED_OFF ) ;
    }
        LedSpeed = 200000;
}

void executeENGINE_OFF( void )
{
        u_int i;
    LedSpeed = 100000;
    

    for ( i=LED8 ; i >= LED1 ; i>>=1 )
    {
	at91_pio_write (&PIOB_DESC, i, LED_ON ) ;
	wait_desc.period = LedSpeed ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, i, LED_OFF ) ;

    }
        LedSpeed = 200000;
}

void executePANIC( void )
{
    int i;

    for(i = 0; i < 5; i++)
    {
	at91_pio_open ( &PIOB_DESC, LED_MASK, PIO_OUTPUT ) ;
	at91_pio_write (&PIOB_DESC, LED_MASK, LED_ON ) ;
	wait_desc.period = 200000 ;

	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, LED_MASK, LED_OFF ) ;
	at91_wait_open ( &wait_desc ) ;
    }
}

void executeUNLOCK_TRUNK( void )
{
    at91_pio_write (&PIOB_DESC, LED2, LED_ON ) ;
    at91_pio_write (&PIOB_DESC, LED6, LED_ON ) ;

    wait_desc.period = 200000 ;

    at91_wait_open ( &wait_desc ) ;
    at91_pio_write (&PIOB_DESC, LED_MASK, LED_OFF ) ;
}

void led_test(u_int tester)
{
    int i;  
    for(i = 0; i < 4; i++)
    {    
	at91_pio_write (&PIOB_DESC, tester, LED_ON ) ;
	wait_desc.period = 200000 ;
	at91_wait_open ( &wait_desc ) ;
	at91_pio_write (&PIOB_DESC, tester, LED_OFF ) ;
	wait_desc.period = 200000 ;
	at91_wait_open ( &wait_desc ) ;	
    }	
}

int main( int argc, char* argv[])
{
    int i = 0;


    initAll();

    /* AH: LED Initialization */
    at91_pio_open (&PIOB_DESC, LED_MASK, PIO_OUTPUT ) ;
    at91_pio_write (&PIOB_DESC, LED_MASK, LED_OFF ) ;

    /* AH: Master clock detection */
    wait_desc.mcki_khz = 32000 ;

    /* AH: Initialize and open USART */
    at91_usart_open(&USART2_DESC, (u_int) US_ASYNC_MODE, (u_int) BAUDS38400, 0);

    while(1)
    {
	i = 0;
	while (i < 10)
	{
	    aByte = recieveByte();

	    if(aByte != 0x0)
	    {
	    /* AH: Recieve signal start of packet transmission */
		akkPacket[i] = aByte;
		i++;
	    } /*if firstByte != 0x0 */

	}/* while */

	if((akkPacket[0] == 0xAA) && (akkPacket[9] == 0xFF))
	{

/* AH: AKK will send a 4 byte packet */
	    for (i=1; i<5; i++)
	    {
		decV0 = (decV0 << 8) + akkPacket[i];

	    }

	    for (i=5; i<9; i++)
	    {
		decV1 = (decV1 << 8) + akkPacket[i];
	    }

	}


	for(i = 0; i < 10;i++)
	{
	    printf("%x\t", akkPacket[i]);
	}

	printf("\n");
# if ADBG

	printf("RECIEVED\t[%X %X]\n", decV0, decV1);
# endif

	/* AH: Decrypt recieved packet */
	buttonV0 = decipherA(decV0, decV1, VIN0, VIN1, VIN2, VIN3);
	buttonV1 = decipherB(decV0, decV1, VIN0, VIN1, VIN2, VIN3);

# if ADBG
	printf("AKV ACTION PACKET\t[%X %X]\n", buttonV0, buttonV1);
# endif

	/* AH: Check AKV Label */
	if(buttonV1 < (serialNum + SERIAL_COUNT))
	{
# if ADBG
	    printf("AKV LABEL DOES NOT MATCH %X\n", buttonV1);
# endif

	}
	else
	{
	    switch(buttonV0)
	    {
		case 0x11111111:
		    executeLOCK();
		    break;
		case 0x11112222:
		    executeUNLOCK();
		    break;	
		case 0x22222222:
		    executeENGINE_ON();
		    break;
		case 0x22223333:
		    executeENGINE_OFF();
		    break;
		case 0x33333333:
		    executePANIC();
		    break;
		default:
		    printf("INTRUDER\n");
		    break;
	    }

	    serialNum = serialNum + SERIAL_COUNT;
	}

	initAll();
    }
    at91_usart_close(&USART2_DESC);
    return(0);
} 
