# include <string.h>
# include <time.h>

# include "parts/m55800/eb55.h"
# include "parts/m55800/lib_m55800.h"
# include "periph/stdc/std_c.h"

# define ADBG	1

/* * * * * * * * * * * AKV-ACTION COMMANDS * * * * * * * * * * */
unsigned int AKV_ACTION		= 	0x99999999; 

unsigned int LOCK 		=	0x11111111; 
unsigned int UNLOCK		=	0x11112222;

unsigned int ENGINE_ON		=	0x22222222;
unsigned int ENGINE_OFF 	= 	0x22223333;

unsigned int PANIC		=	0x33333333;

unsigned int UNLOCK_TRUNK	=	0x44444444;
/* * * * * * * * * * * AKV-ACTION COMMANDS * * * * * * * * * * */

unsigned int verifyAKVlabel(void)
{
    return AKV_ACTION;
}

unsigned int verifyAKVcommand(void)
{
    time_t first;
    
    for(;;)
    {
	u_int status = at91_pio_read (&PIOB_DESC) ;
	u_int astatus = at91_pio_read (&PIOA_DESC) ;
	
	if ((status & (1<<PIO_SW1)) == 0 )
	{
   	    time(&first);		
	    at91_pio_write (&PIOB_DESC, LED8, LED_ON ) ;

	    /* Check if switch 1 was pressed again */
	    while ((at91_pio_read (&PIOB_DESC) & (1<<PIO_SW1)) != 0)
	    {
		/* Check how much time has passed if switch 1 was not pressed */
		if (difftime(time(NULL), first) > 5)
		{
		    at91_pio_write (&PIOB_DESC, LED8, LED_OFF );
# if ADBG
		    printf("AKV REQUEST:\t\tUNLOCK DOORS \n");
# endif
		    return UNLOCK;
		}
	    }
	    at91_pio_write (&PIOB_DESC, LED8, LED_OFF ) ;
# if ADBG
	    printf("AKV REQUEST:\t\tLOCK DOORS\n");
# endif 
	    return LOCK;
	}	
	else if ((astatus & (1<<PIO_SW2)) == 0 )
	{
	    time(&first);		
	    at91_pio_write (&PIOB_DESC, LED8, LED_ON ) ;
	    while ((at91_pio_read (&PIOA_DESC) & (1<<PIO_SW2)) != 0)
	    {
		if (difftime(time(NULL), first) >5)
		{
		    at91_pio_write (&PIOB_DESC, LED8, LED_OFF ) ;
# if ADBG
		    printf("AKV REQUEST:\t\tENGINE OFF\n");
# endif
		    return ENGINE_OFF;
		}
	    }
	    at91_pio_write (&PIOB_DESC, LED8, LED_OFF ) ;
# if ADBG
	    printf("AKV REQUEST:\t\tENGINE ON\n");
# endif
	    return ENGINE_ON;
	}
	else if ((status & (1<<PIO_SW3)) == 0 )
	{
# if ADBG
	    printf("AKV REQUEST:\t\tPANIC\n");
# endif
	    return PANIC;
	}
	else if ((status & (1<<PIO_SW4)) == 0 )
	{
# if ADBG
	    printf("AKV REQUEST:\t\tUNLOCK TRUNK\n");
# endif
	    return UNLOCK_TRUNK;
	}
    }  
}
